#include "stdafx.h"
#include "sgRegExp.h"
#include "Substring.h"


STDMETHODIMP Substring::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_ISubstring,
	};
	for (int i=0;i<sizeof(arr)/sizeof(arr[0]);i++)
	{
		if (InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}


STDMETHODIMP Substring::get_Value(/*[out, retval]*/ BSTR* res)
{
	if (res == 0)
		return E_POINTER;

	*res = m_Value.copy();
	return S_OK;
}

STDMETHODIMP Substring::get_Start(/*[out, retval]*/ long* res)
{
	if (res == 0)
		return E_POINTER;

	*res = m_Start+1;
	return S_OK;
}

STDMETHODIMP Substring::get_Length(/*[out, retval]*/ long* res)
{
	if (res == 0)
		return E_POINTER;

	*res = m_Length;
	return S_OK;
}
